diff --git a/src/lxc/conf.c b/src/lxc/conf.c
index 5962009e34..b8058ffdce 100644
--- a/src/lxc/conf.c
+++ b/src/lxc/conf.c
@@ -1531,13 +1531,15 @@ static int lxc_setup_devpts(struct lxc_handler *handler)
 
 	devpts_fd = openat(-EBADF, "/dev/pts", O_CLOEXEC | O_DIRECTORY | O_PATH | O_NOFOLLOW);
 	if (devpts_fd < 0) {
+		devpts_fd = -EBADF;
 		TRACE("Failed to create detached devpts mount");
-		ret = lxc_abstract_unix_send_fds(sock, NULL, 0, NULL, 0);
+		ret = lxc_abstract_unix_send_fds(sock, NULL, 0, &devpts_fd, sizeof(int));
 	} else {
 		ret = lxc_abstract_unix_send_fds(sock, &devpts_fd, 1, NULL, 0);
 	}
 	if (ret < 0)
 		return log_error_errno(-1, errno, "Failed to send devpts fd to parent");
+	TRACE("Sent devpts file descriptor %d to parent", devpts_fd);
 
 	/* Remove any pre-existing /dev/ptmx file. */
 	ret = remove("/dev/ptmx");
diff --git a/src/lxc/start.c b/src/lxc/start.c
index 322debf00f..7b29d40834 100644
--- a/src/lxc/start.c
+++ b/src/lxc/start.c
@@ -1953,13 +1953,14 @@ static int lxc_spawn(struct lxc_handler *handler)
 		}
 	}
 
-	ret = lxc_abstract_unix_recv_fds(data_sock1, &handler->conf->devpts_fd, 1, NULL, 0);
+	ret = lxc_abstract_unix_recv_fds(data_sock1, &handler->conf->devpts_fd, 1,
+					 &handler->conf->devpts_fd,
+					 sizeof(handler->conf->devpts_fd));
 	if (ret < 0) {
 		SYSERROR("Failed to receive devpts fd from child");
 		goto out_delete_net;
 	}
-	if (ret == 0)
-		handler->conf->devpts_fd = -EBADF;
+	TRACE("Received devpts file descriptor %d from child", handler->conf->devpts_fd);
 
 	/* Now all networks are created, network devices are moved into place,
 	 * and the correct names and ifindices in the respective namespaces have
